# Class PluginUnderTestMetadata

java.lang.Object
org.gradle.api.internal.AbstractTask
org.gradle.api.DefaultTask
org.gradle.plugin.devel.tasks.PluginUnderTestMetadata

All Implemented Interfaces:
  `Comparable<Task>, org.gradle.api.internal.DynamicObjectAware, org.gradle.api.internal.TaskInternal, Named, ExtensionAware, Task, Configurable<Task>`

@DisableCachingByDefault(because="Not worth caching") public abstract class PluginUnderTestMetadata extends DefaultTask
Custom task for generating the metadata for a plugin user test.

Since:
  2.13

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from interface Named

  `Named.Namer`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `IMPLEMENTATION_CLASSPATH_PROP_KEY`
  The implementation classpath prop key.
  `static final String`
  `METADATA_FILE_NAME`
  The metadata file name.

  ### Fields inherited from interface Task

  `TASK_ACTION, TASK_CONSTRUCTOR_ARGS, TASK_DEPENDS_ON, TASK_DESCRIPTION, TASK_GROUP, TASK_NAME, TASK_OVERWRITE, TASK_TYPE`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PluginUnderTestMetadata()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `generate()`
  Generate.
  `abstract DirectoryProperty`
  `getOutputDirectory()`
  The target output directory used for writing the classpath manifest.
  `protected List<String>`
  `getPaths()`
  Returns the paths.
  `abstract ConfigurableFileCollection`
  `getPluginClasspath()`
  The code under test.

  ### Methods inherited from class DefaultTask

  `compareTo, configure, dependsOn, doFirst, doFirst, doFirst, doLast, doLast, doLast, finalizedBy, getActions, getAnt, getDependsOn, getDescription, getDestroyables, getDidWork, getEnabled, getExtensions, getFinalizedBy, getGroup, getInputs, getLocalState, getLogger, getLogging, getMustRunAfter, getName, getOutputs, getPath, getProject, getShouldRunAfter, getState, getTaskDependencies, getTemporaryDir, getTimeout, hasProperty, mustRunAfter, onlyIf, onlyIf, onlyIf, property, setActions, setDependsOn, setDescription, setDidWork, setEnabled, setFinalizedBy, setGroup, setMustRunAfter, setOnlyIf, setOnlyIf, setOnlyIf, setProperty, setShouldRunAfter, shouldRunAfter, usesService`

  ### Methods inherited from class org.gradle.api.internal.AbstractTask

  `acceptServiceReferences, appendParallelSafeAction, doNotTrackState, doNotTrackStateIf, getAsDynamicObject, getIdentityPath, getImpliesSubProjects, getLifecycleDependencies, getLoggingManager, getOnlyIf, getReasonNotToTrackState, getReasonsNotToTrackState, getReasonTaskIsIncompatibleWithConfigurationCache, getRequiredServices, getServices, getSharedResources, getStandardOutputCapture, getTaskActions, getTaskIdentity, getTemporaryDirFactory, hasTaskActions, injectIntoNewInstance, isCompatibleWithConfigurationCache, isEnabled, isHasCustomActions, notCompatibleWithConfigurationCache, prependParallelSafeAction, restoreOnlyIf, restoreTaskActions, service, setImpliesSubProjects`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface Task

  `doNotTrackState, notCompatibleWithConfigurationCache, service`

- ## Field Details

  - ### IMPLEMENTATION_CLASSPATH_PROP_KEY

    public static final String IMPLEMENTATION_CLASSPATH_PROP_KEY
    The implementation classpath prop key.
    Since:
      2.13
    See Also:
      - Constant Field Values

  - ### METADATA_FILE_NAME

    public static final String METADATA_FILE_NAME
    The metadata file name.
    Since:
      2.13
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### PluginUnderTestMetadata

    public PluginUnderTestMetadata()

- ## Method Details

  - ### getPluginClasspath

    @Classpath public abstract ConfigurableFileCollection getPluginClasspath()
    The code under test. Defaults to `sourceSets.main.runtimeClasspath`.
    Since:
      2.13

  - ### getOutputDirectory

    @OutputDirectory public abstract DirectoryProperty getOutputDirectory()
    The target output directory used for writing the classpath manifest. Defaults to `"$buildDir/$task.name"`.
    Since:
      2.13

  - ### generate

    public void generate()
    Generate.
    Since:
      2.13

  - ### getPaths

    @Input protected List<String> getPaths()
    Returns the paths.
    Since:
      4.4